# class Chef::ApiClient

### Public Class Methods

http_api() click to toggle source

    # File lib/chef/api_client.rb, line 137
    def self.http_api
      Chef::REST.new(Chef::Config[:chef_server_url])
    end

json_create(o) click to toggle source

    # File lib/chef/api_client.rb, line 127
    def self.json_create(o)
      client = Chef::ApiClient.new
      client.name(o["name"] || o["clientname"])
      client.private_key(o["private_key"]) if o.key?("private_key")
      client.public_key(o["public_key"])
      client.admin(o["admin"])
      client.validator(o["validator"])
      client
    end

list(inflate=false) click to toggle source

    # File lib/chef/api_client.rb, line 146
    def self.list(inflate=false)
      if inflate
        response = Hash.new
        Chef::Search::Query.new.search(:client) do |n|
          n = self.json_create(n) if n.instance_of?(Hash)
          response[n.name] = n
        end
        response
      else
        http_api.get("clients")
      end
    end

load(name) click to toggle source

Load a client by name via the API

    # File lib/chef/api_client.rb, line 160
    def self.load(name)
      response = http_api.get("clients/#{name}")
      if response.kind_of?(Chef::ApiClient)
        response
      else
        json_create(response)
      end
    end

new() click to toggle source

Create a new Chef::ApiClient object.

    # File lib/chef/api_client.rb, line 34
    def initialize
      @name = ''
      @public_key = nil
      @private_key = nil
      @admin = false
      @validator = false
    end

reregister(name) click to toggle source

    # File lib/chef/api_client.rb, line 141
    def self.reregister(name)
      api_client = load(name)
      api_client.reregister
    end

### Public Instance Methods

admin(arg=nil) click to toggle source

Gets or sets whether this client is an admin.

@params [Optional True/False] Should be true or false - default is false. @return [True/False] The current value

    # File lib/chef/api_client.rb, line 58
    def admin(arg=nil)
      set_or_return(
        :admin,
        arg,
        :kind_of => [ TrueClass, FalseClass ]
      )
    end

create() click to toggle source

Create the client via the REST API

    # File lib/chef/api_client.rb, line 199
    def create
      http_api.post("clients", self)
    end

destroy() click to toggle source

Remove this client via the REST API

    # File lib/chef/api_client.rb, line 170
    def destroy
      http_api.delete("clients/#{@name}")
    end

http_api() click to toggle source

    # File lib/chef/api_client.rb, line 213
    def http_api
      @http_api ||= Chef::REST.new(Chef::Config[:chef_server_url])
    end

inspect() click to toggle source

    # File lib/chef/api_client.rb, line 208
    def inspect
      "Chef::ApiClient name:'#{name}' admin:'#{admin.inspect}' validator:'#{validator}' " +
      "public_key:'#{public_key}' private_key:'#{private_key}'"
    end

name(arg=nil) click to toggle source

Gets or sets the client name.

@params [Optional String] The name must be alpha-numeric plus - and _. @return [String] The current value of the name.

    # File lib/chef/api_client.rb, line 46
    def name(arg=nil)
      set_or_return(
        :name,
        arg,
        :regex => /^[\-[:alnum:]_\.]+$/
      )
    end

private_key(arg=nil) click to toggle source

Gets or sets the private key.

@params [Optional String] The string representation of the private key. @return [String] The current value.

    # File lib/chef/api_client.rb, line 95
    def private_key(arg=nil)
      set_or_return(
        :private_key,
        arg,
        :kind_of => String
      )
    end

public_key(arg=nil) click to toggle source

Gets or sets the public key.

@params [Optional String] The string representation of the public key. @return [String] The current value.

    # File lib/chef/api_client.rb, line 70
    def public_key(arg=nil)
      set_or_return(
        :public_key,
        arg,
        :kind_of => String
      )
    end

reregister() click to toggle source

    # File lib/chef/api_client.rb, line 188
    def reregister
      reregistered_self = http_api.put("clients/#{name}", { :name => name, :admin => admin, :validator => validator, :private_key => true })
      if reregistered_self.respond_to?(:[])
        private_key(reregistered_self["private_key"])
      else
        private_key(reregistered_self.private_key)
      end
      self
    end

save() click to toggle source

Save this client via the REST API, returns a hash including the private key

    # File lib/chef/api_client.rb, line 175
    def save
      begin
        http_api.put("clients/#{name}", { :name => self.name, :admin => self.admin, :validator => self.validator})
      rescue Net::HTTPServerException => e
        # If that fails, go ahead and try and update it
        if e.response.code == "404"
          http_api.post("clients", {:name => self.name, :admin => self.admin, :validator => self.validator })
        else
          raise e
        end
      end
    end

to_hash() click to toggle source

The hash representation of the object. Includes the name and public_key. Private key is included if available.

@return [Hash]

    # File lib/chef/api_client.rb, line 107
    def to_hash
      result = {
        "name" => @name,
        "public_key" => @public_key,
        "validator" => @validator,
        "admin" => @admin,
        'json_class' => self.class.name,
        "chef_type" => "client"
      }
      result["private_key"] = @private_key if @private_key
      result
    end

to_json(*a) click to toggle source

The JSON representation of the object.

@return [String] the JSON string.

    # File lib/chef/api_client.rb, line 123
    def to_json(*a)
      to_hash.to_json(*a)
    end

to_s() click to toggle source

As a string

    # File lib/chef/api_client.rb, line 204
    def to_s
      "client[#{@name}]"
    end

validator(arg=nil) click to toggle source

Gets or sets whether this client is a validator.

@params [Boolean] whether or not the client is a validator. If

    `nil`, retrieves the already-set value.

@return [Boolean] The current value

    # File lib/chef/api_client.rb, line 83
    def validator(arg=nil)
      set_or_return(
        :validator,
        arg,
        :kind_of => [TrueClass, FalseClass]
      )
    end